Lattice Grid Buy a licence

demo D305

How much furniture to show in React

Heading controls, scrollbars and cell alignment, switched on screen

headerControls

Three switches over one grid: whether the heading controls appear on hover, stay put or disappear entirely; whether the scrollbars stay on screen; and whether cell content sits at the top, middle or bottom of its row.

Building…
Loading a live grid…

This is the React version. The grid mounts through the createLatticeGrid adapter, which takes its configuration as ordinary props and hands back the live grid through a ref. The grid below is the same one every other tab runs.

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.70.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.70.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.70.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { pin: 'start', width: 190 }, filter: true },
    { field: 'region', title: 'Region' },
    { field: 'status', title: 'Status', filter: { type: 'set' } },
    { field: 'bandwidth', title: 'Bandwidth', type: 'number', filter: { type: 'number' } },
  ];

  const rows = [/* circuit records */];
  const modes = ['hover', 'always', 'hidden', 'none'];

  function App() {
    // headerControls, as a default for every column. 'hover' reveals the sort
    // arrow, filter funnel and menu button on hover or focus; 'always' keeps
    // them visible; 'hidden' draws none of them but still shows a read-only
    // sort badge on a column that is actually sorted; 'none' goes further and
    // shows the title only, whatever the grid's state - not even hidden's
    // badge. Built for a NOC wall display, where a heading must never change
    // its own look however the dashboard driving it sorts or filters.
    const [mode, setMode] = React.useState('hover');

    return (
      <>
        <div style={{ display: 'flex', gap: '8px', marginBottom: '10px' }}>
          {modes.map((m) => (
            <button key={m} onClick={() => setMode(m)} aria-pressed={m === mode}>{m}</button>
          ))}
        </div>
        <LatticeGrid
          rowKey="id"
          headerControls={mode}
          columns={columns}
          rows={rows}
          // Sorted and filtered from the start, so hidden's read-only sort
          // badge on Bandwidth versus none's bare title is the thing on
          // screen to compare, not something a visitor has to go and cause
          // first.
          sort={[{ col: 'bandwidth', dir: 'desc' }]}
          filters={{ col: 'status', op: 'eq', value: 'live' }}
          style={{ height: '540px' }}
        />
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

Deciding how much furniture a data grid shows

A grid embedded in a product rarely wants the same amount of chrome as a grid on its own page. A dense read-only report wants clean headings; a table people sort and filter all day wants the controls in plain sight rather than hidden until hover; a dashboard panel on a machine with overlay scrollbars wants the scrollbars pinned so the amount of data below the fold is never a surprise. Lattice Grid puts each of those on a single configuration key, settable as a grid-wide default and overridable on an individual column.

Heading controls, the sort arrow, filter funnel and menu button, can be revealed on hover and keyboard focus, kept visible at all times, or drawn not at all. Hidden also takes them out of the tab order, which is the right behaviour for a heading that is genuinely just a label; sorting and filtering remain reachable from the tool panel and the keyboard, so hiding the furniture never removes the function. Scrollbars can follow the platform’s own behaviour or be kept on screen, on both axes or on one. Cell content can be aligned to the top, middle or foot of its row, which is what a tall row of wrapped text usually needs, and it applies uniformly including to rows that size themselves to their content unless a column opts out.

Each of these is unset or platform-default out of the box, so an existing grid renders exactly as it did until you ask for something different.

How do you keep a data grid’s sort and filter buttons always visible?

Set headerControls to always. The sort arrow, filter funnel and menu button stay on screen instead of appearing on hover. Set it to hidden for a heading that should be a plain label, or leave it on hover for the default behaviour. A column’s own setting overrides the grid’s.

How do you stop a data grid’s scrollbars from fading out?

Set scrollbars to always, which keeps both axes visible whether or not the pointer is over the grid. Pass an object naming each axis to pin only one of them, for example keeping the vertical bar while leaving the horizontal one to the platform.

Lattice Grid Buy a licence

demo D305

How much furniture to show in Angular

Heading controls, scrollbars and cell alignment, switched on screen

headerControls

Three switches over one grid: whether the heading controls appear on hover, stay put or disappear entirely; whether the scrollbars stay on screen; and whether cell content sits at the top, middle or bottom of its row.

Building…
Loading a live grid…

This is the Angular version. A standalone component takes the whole configuration through one config input, surfaces grid events as outputs, and exposes the live grid on a getter for anything the inputs do not cover.

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { CommonModule } from '@angular/common';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const columns = [
  { field: 'circuit', title: 'Circuit', layout: { pin: 'start', width: 190 }, filter: true },
  { field: 'region', title: 'Region' },
  { field: 'status', title: 'Status', filter: { type: 'set' } },
  { field: 'bandwidth', title: 'Bandwidth', type: 'number', filter: { type: 'number' } },
];

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, LatticeGridComponent],
  template:
    '<div style="display:flex;gap:8px;margin-bottom:10px">' +
    '  <button *ngFor="let m of modes" (click)="setMode(m)" [attr.aria-pressed]="m === mode">{{ m }}</button>' +
    '</div>' +
    '<lattice-grid [config]="grid" [sort]="sort" [filters]="filters" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  // headerControls, as a default for every column. 'hover' reveals the sort
  // arrow, filter funnel and menu button on hover or focus; 'always' keeps
  // them visible; 'hidden' draws none of them but still shows a read-only
  // sort badge on a column that is actually sorted; 'none' goes further and
  // shows the title only, whatever the grid's state - not even hidden's
  // badge. Built for a NOC wall display, where a heading must never change
  // its own look however the dashboard driving it sorts or filters.
  modes = ['hover', 'always', 'hidden', 'none'];
  mode = 'hover';

  // Sorted and filtered from the start, so hidden's read-only sort badge on
  // Bandwidth versus none's bare title is the thing on screen to compare.
  sort = [{ col: 'bandwidth', dir: 'desc' }];
  filters = { col: 'status', op: 'eq', value: 'live' };

  grid: any = {
    rowKey: 'id',
    headerControls: this.mode,
    columns,
    rows: [/* circuit records */],
  };

  setMode(m: string) {
    this.mode = m;
    this.grid = { ...this.grid, headerControls: m };
  }
}

bootstrapApplication(AppComponent);

Deciding how much furniture a data grid shows

A grid embedded in a product rarely wants the same amount of chrome as a grid on its own page. A dense read-only report wants clean headings; a table people sort and filter all day wants the controls in plain sight rather than hidden until hover; a dashboard panel on a machine with overlay scrollbars wants the scrollbars pinned so the amount of data below the fold is never a surprise. Lattice Grid puts each of those on a single configuration key, settable as a grid-wide default and overridable on an individual column.

Heading controls, the sort arrow, filter funnel and menu button, can be revealed on hover and keyboard focus, kept visible at all times, or drawn not at all. Hidden also takes them out of the tab order, which is the right behaviour for a heading that is genuinely just a label; sorting and filtering remain reachable from the tool panel and the keyboard, so hiding the furniture never removes the function. Scrollbars can follow the platform’s own behaviour or be kept on screen, on both axes or on one. Cell content can be aligned to the top, middle or foot of its row, which is what a tall row of wrapped text usually needs, and it applies uniformly including to rows that size themselves to their content unless a column opts out.

Each of these is unset or platform-default out of the box, so an existing grid renders exactly as it did until you ask for something different.

How do you keep a data grid’s sort and filter buttons always visible?

Set headerControls to always. The sort arrow, filter funnel and menu button stay on screen instead of appearing on hover. Set it to hidden for a heading that should be a plain label, or leave it on hover for the default behaviour. A column’s own setting overrides the grid’s.

How do you stop a data grid’s scrollbars from fading out?

Set scrollbars to always, which keeps both axes visible whether or not the pointer is over the grid. Pass an object naming each axis to pin only one of them, for example keeping the vertical bar while leaving the horizontal one to the platform.